// ****************************************************************************
// offload simple openmp region
// compile with: icc -openmp 
//
// CAUTION: cannot use const int N = xxxx to define the array size in C.
//          The icc compiler puts this on the heap and the offload fails.
//          The icpc compiler is more liberal and handles this fine.
//
// CAUTION: default stack limit is only 12MB. Use MIC_STACKSIZE to adjust!
//          (For some reason 3MB stack works for size = 500000; my calcs
//          say this shouldn't work.)
//
// djames (at) tacc.utexas.edu
// 29 Sep 2013
// ****************************************************************************

#include <stdio.h>
#include <omp.h>

// -------------------------------------------------------------------

int main( void ) {

  double a[500000];
    // on the stack; literal here is important
  int i;

  #pragma offload target(mic:0)    
//  #pragma offload target(mic)    
    #pragma omp parallel for
      for ( i=0; i<500000; i++ )  {
        a[i] = (double)i;
      }

 
  printf( "\n\t last val  = %f \n", a[500000-1]);

  return 0;

}
