! ******************************************************************************
! offload simple openmp region
! compile with: ifort -openmp
!
! Unlike C, you CAN define array size using a const (parameter).
! See more on this in the comments for equivalent C code.
!
! CAUTION: default stack limit is only 12MB. Use MIC_STACKSIZE to adjust!
!
! djames (at) tacc.utexas.edu
! 29 Sep 2013
! ******************************************************************************

program main

  integer, parameter :: N = 500000  ! constant 
  real(8)            :: a(N)        ! on stack

  !dir$ offload target(mic)
    !$omp parallel do
      do i=1,N
        a(i) = real(i)
      end do
    !$omp end parallel do

  print*, "last val is ", a(N)

end program

