// ****************************************************************************
// local vs global data
// compile with: icc -openmp
//
// djames (at) tacc.utexas.edu
// 29 Sep 2013
// ****************************************************************************

#include <stdio.h>
#include <omp.h>

int myGlobalInt;
//__declspec( target(mic) ) int myGlobalInt;
__attribute__((target(mic))) int myGlobalInt;

int main( void ) {

  double tstart, tend;

  int myLocalInt = 123;
  //static int myStaticInt;
  //__declspec( target(mic) ) static int myStaticInt;
  __attribute__( ( target(mic) ) ) int myStaticInt;

  tstart = omp_get_wtime();
  #pragma offload target(mic)
    {
      myGlobalInt = 2 * myLocalInt;
      myStaticInt = 2 * myGlobalInt;
    }
  tend = omp_get_wtime();

  printf("\n Off05 completed in %9.5f seconds.", tend-tstart );
  printf( "\n\t  myLocalInt = %d",     myLocalInt  );
  printf( "\n\t myGlobalInt = %d",     myGlobalInt );
  printf( "\n\t myStaticInt = %d\n\n", myStaticInt );

  return 0;

}
