! ******************************************************************************
! offload array on stack
! compile with: ifort -openmp
!
! CAUTION: default stacksize is 12MB
!
! djames (at) tacc.utexas.edu
! 26 Sep 2013
!
! Revision History
! ****************
!
!   04 Oct 2013   Removed alloc_if and free_if.  These apparently have
!                 no effect on stack-based arrays.  To see this, deliberately
!                 set alloc_if(0) on all arrays.
! ******************************************************************************

program main

  implicit none

  integer, parameter :: N = 100000              ! constant 
  real(8)            :: a(N), b(N), c(N), d(N)  ! on stack

  integer            :: i;

  do i=1,N
    a(i) = 1.0d0
    b(i) = real(i)
  end do

  !dir$ offload target(mic)            &
   in( a ), out( c, d ), inout( b )   
    !$omp parallel do
      do i=1,N
        c(i) =  a(i) + b(i)
        d(i) =  a(i) - b(i)
        b(i) = -b(i)
      end do
    !$omp end parallel do

  print*, "last a val is ", a(N)
  print*, "last b val is ", b(N)
  print*, "last c val is ", c(N)
  print*, "last d val is ", d(N)

end program

