! ******************************************************************************
! verify allocatable arays don't need length attribute
! compile with: ifort -openmp
!
! djames (at) tacc.utexas.edu
! 29 Sep 2013
! ******************************************************************************

program main

  implicit none

  real(8), allocatable         :: a(:), b(:)
  !dir$ attributes align:64 :: a
  !dir$ attributes align:64 :: b

  integer, parameter :: N = 5000000
  integer            :: i

  allocate(  a(N), b(N)  )

  do i=1,N
    a(i) = real(i)
  end do

  !dir$ offload target(mic)                     &
   in(  a : alloc_if(.true.) free_if(.true.) ), &
   out( b : alloc_if(.true.) free_if(.true.) )
    !$omp parallel do
      do i=1,N
        b(i) = 2.0 * a(i)
      end do
    !$omp end parallel do

  print*, "last a val is ", a(N)
  print*, "last b val is ", b(N)

  deallocate( a )
  deallocate( b )

end program

