! ******************************************************************************
! simple async demo/test
! compile with: ifort -openmp
!
! "wait" requires explicit mic device number.
! But "attributes" apparently can't take one at all.
!
! If signal is initialized to POSITIVE value the code works.
! If signal is initialized to 0 or negative value, the code crashes.
!
! See C version for more detailed comments.
!
! djames (at) tacc.utexas.edu
! 26 Sep 2013
!
!   09 Jul 2014   Gave tag its own unique identifier
!
! ******************************************************************************

module utils

  contains

    !dir$ attributes offload:mic :: incrementslowly
    subroutine incrementslowly( m )
      use ifport
      call sleepqq(5000)
      m = m + 1 
    end subroutine incrementslowly

end module utils

! -------------------------------------------------------------------

program main

  use iso_fortran_env
  use omp_lib
  use utils

  implicit none
  integer  :: n = 123
  integer  :: tag = 1

  !dir$ offload begin target(mic:0)  signal( tag )
    call incrementslowly( n )
  !dir$ end offload

  !dir$ offload_wait target(mic:0)  wait( tag )
!!!dir$ offload begin target(mic:0) 
    print *, "  procs: ", omp_get_num_procs()
    call flush(0)
!!!dir$ end offload

  if ( n .eq. 123 )  then
    print *, "  The offload increment has NOT finished..."
  else
    print *, "  The offload increment DID finish successfully..."
  endif

  print *, "  n: ", n

end program
