! ******************************************************************************
! offload_transfer demo
! compile with: ifort -openmp
!
! djames (at) tacc.utexas.edu
! 27 Sep 2013
! ******************************************************************************

program main

  implicit none

  real, allocatable  :: a(:), b(:)
  !dir$ attributes align:64 :: a
  !dir$ attributes align:64 :: b

  integer, parameter :: N = 5000000
  integer            :: i
  integer            :: tag1 = 1   ! Tags may soon have to be 8-byte
  integer            :: tag2 = 2
  integer            :: tag3 = 3
    ! Intel sample code says to use unique tag numbers. Can't find this
    ! in any documentation, and it doesn't seem to affect execution here.

  allocate(  a(N), b(N)  )

  !dir$ offload_transfer target(mic:0)               &
   nocopy( a : alloc_if(.true.) free_if(.false.) ),  &
   nocopy( b : alloc_if(.true.) free_if(.false.) )   &
   signal( tag1 )

  do i=1,N
    a(i) = real(i)
  end do

  !dir$ offload target(mic:0) wait( tag1 )           &
   in(     a : alloc_if(.false.) free_if(.false.) ), &
   nocopy( b : alloc_if(.false.) free_if(.false.) )  &
   signal( tag2 )
    !$omp parallel do
      do i=1,N
        b(i) = 2.0 * a(i)
      end do
    !$omp end parallel do

  !dir$ offload_transfer target(mic:0) wait( tag2 )  &
   nocopy( a : alloc_if(.false.) free_if(.true.) ),  &
   out(    b : alloc_if(.false.) free_if(.true.) )   &
   signal( tag3 )

  !dir$ offload_wait target(mic:0) wait( tag3 )

  print*, "last a val is ", a(N-1)
  print*, "last b val is ", b(N-1)

  deallocate( a )
  deallocate( b )

end program

